#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the test programs
# C/C++ Compiler Used: GNU g++ 2.7.2.1 
# Produced By: Doug Gaer
# File Creation Date: 09/05/97 
# Date Last Modified: 11/03/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v                   -- Echo compilation
#       g                   -- Enable debugging
#       Wall                -- Turn on warnings 
#       -fhandle-exceptions -- Enable C++ exception handling
#       -frtti              -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT1 = testi32
PROJECT2 = testu32
PROJECT3 = testi16
PROJECT4 = testu16
PROJECT5 = testf64

# Define macros for compiler and linker
CC = gcc
CPP = g++
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -fhandle-exceptions
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.o:
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

.cpp.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.cc.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.C.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<
# ===============================================================

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ehandler.hpp

INT32_DEP = int32.hpp ehandler.hpp dtypes.hpp

TESTI32_DEP = int32.hpp ehandler.hpp dtypes.hpp

UINT32_DEP = uint32.hpp ehandler.hpp dtypes.hpp

TESTU32_DEP = uint32.hpp ehandler.hpp dtypes.hpp

INT16_DEP = int16.hpp ehandler.hpp dtypes.hpp

TESTI16_DEP = int16.hpp ehandler.hpp dtypes.hpp

UINT16_DEP = uint16.hpp ehandler.hpp dtypes.hpp

TESTU16_DEP = uint16.hpp ehandler.hpp dtypes.hpp

FLOAT64_DEP = float64.hpp ehandler.hpp dtypes.hpp machine.hpp

TESTF64_DEP = float64.hpp ehandler.hpp dtypes.hpp machine.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT1) $(PROJECT2) $(PROJECT3) $(PROJECT4) $(PROJECT5)

TESTI32:	$(PROJECT1)

ehandler.o:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

int32.o:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

testi32.o:	testi32.cpp $(TESTI32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi32.cpp

OBJS_PROJECT1 = ehandler.o testi32.o int32.o 

$(PROJECT1):	$(OBJS_PROJECT1)
	$(CPP) $(CFLAGS) $(OBJS_PROJECT1) $(OUTPUT) $(PROJECT1) 

TESTU32:	$(PROJECT2)

uint32.o:	uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) uint32.cpp

testu32.o:	testu32.cpp $(TESTU32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu32.cpp

OBJS_PROJECT2 = ehandler.o testu32.o uint32.o 

$(PROJECT2):	$(OBJS_PROJECT2)
	$(CPP) $(CFLAGS) $(OBJS_PROJECT2) $(OUTPUT) $(PROJECT2) 

TESTI16:	($PROJECT3)

int16.o:	int16.cpp $(INT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int16.cpp

testi16.o:	testi16.cpp $(TESTI16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi16.cpp

OBJS_PROJECT3 = ehandler.o testi16.o int16.o 

$(PROJECT3):	$(OBJS_PROJECT3)
	$(CPP) $(CFLAGS) $(OBJS_PROJECT3) $(OUTPUT) $(PROJECT3) 

TESTU16:	($PROJECT4)

uint16.o:	uint16.cpp $(UINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) uint16.cpp

testu16.o:	testu16.cpp $(TESTU16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu16.cpp

OBJS_PROJECT4 = ehandler.o testu16.o uint16.o 

$(PROJECT4):	$(OBJS_PROJECT4)
	$(CPP) $(CFLAGS) $(OBJS_PROJECT4) $(OUTPUT) $(PROJECT4) 

TESTF64:	($PROJECT5)

float64.o:	float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) float64.cpp

testf64.o:	testf64.cpp $(TESTF64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testf64.cpp

OBJS_PROJECT5 = ehandler.o testf64.o float64.o 

$(PROJECT5):	$(OBJS_PROJECT5)
	$(CPP) $(CFLAGS) $(OBJS_PROJECT5) $(OUTPUT) $(PROJECT5) 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT1)

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT2)

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT3)

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT4)

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT5)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
