#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the test programs
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2
# Produced By: Doug Gaer
# File Creation Date: 09/05/97 
# Date Last Modified: 09/15/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#       GX -- Enable C++ exception handling
#       GR -- Enable C++ Run-Time Type Information
# 	Zp -- Byte align structures (leave no gaps between members)
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT1 = testi32
PROJECT2 = testu32
PROJECT3 = testi16
PROJECT4 = testu16
PROJECT5 = testf64

# Define macros for compiler and linker
CC = cl
CPP = cl
LINKER = link

# Define compiler and linker flags macros
CFLAGS= /Zi /GX
COMPILE_ONLY = /c
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.obj:
	$(CC) $(CFLAGS) $(COMPILE_ONLY) $*.c

.cpp.obj:
	$(CPP) $(CFLAGS) $(COMPILE_ONLY) $*.cpp
# ===============================================================

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ehandler.hpp

INT32_DEP = int32.hpp ehandler.hpp dtypes.hpp

TESTI32_DEP = int32.hpp ehandler.hpp dtypes.hpp

UINT32_DEP = uint32.hpp ehandler.hpp dtypes.hpp

TESTU32_DEP = uint32.hpp ehandler.hpp dtypes.hpp

INT16_DEP = int16.hpp ehandler.hpp dtypes.hpp

TESTI16_DEP = int16.hpp ehandler.hpp dtypes.hpp

UINT16_DEP = uint16.hpp ehandler.hpp dtypes.hpp

TESTU16_DEP = uint16.hpp ehandler.hpp dtypes.hpp

FLOAT64_DEP = float64.hpp ehandler.hpp dtypes.hpp machine.hpp

TESTF64_DEP = float64.hpp ehandler.hpp dtypes.hpp machine.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT1).exe $(PROJECT2).exe $(PROJECT3).exe $(PROJECT4).exe \
	$(PROJECT5).exe

ehandler.obj:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

int32.obj:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

testi32.obj:	testi32.cpp $(TESTI32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi32.cpp

uint32.obj:	uint32.cpp $(UINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) uint32.cpp

testu32.obj:	testu32.cpp $(TESTU32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu32.cpp

int16.obj:	int16.cpp $(INT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int16.cpp

testi16.obj:	testi16.cpp $(TESTI16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testi16.cpp

uint16.obj:	uint16.cpp $(UINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) uint16.cpp

testu16.obj:	testu16.cpp $(TESTU16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testu16.cpp

float64.obj:	float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) float64.cpp

testf64.obj:	testf64.cpp $(TESTF64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testf64.cpp

# Make the executable
OBJS_PROJECT1 = ehandler.obj testi32.obj int32.obj 
OBJS_PROJECT2 = ehandler.obj testu32.obj uint32.obj 
OBJS_PROJECT3 = ehandler.obj testi16.obj int16.obj 
OBJS_PROJECT4 = ehandler.obj testu16.obj uint16.obj 
OBJS_PROJECT5 = ehandler.obj testf64.obj float64.obj 

$(PROJECT1).exe:	$(OBJS_PROJECT1)
        $(LINKER) $(LFLAGS) $(OBJS_PROJECT1) /OUT:$@ 

$(PROJECT2).exe:	$(OBJS_PROJECT2)
        $(LINKER) $(LFLAGS) $(OBJS_PROJECT2) /OUT:$@ 

$(PROJECT3).exe:	$(OBJS_PROJECT3)
        $(LINKER) $(LFLAGS) $(OBJS_PROJECT3) /OUT:$@ 

$(PROJECT4).exe:	$(OBJS_PROJECT4)
        $(LINKER) $(LFLAGS) $(OBJS_PROJECT4) /OUT:$@ 

$(PROJECT5).exe:	$(OBJS_PROJECT5)
        $(LINKER) $(LFLAGS) $(OBJS_PROJECT5) /OUT:$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT1).exe del $(PROJECT1).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT2).exe del $(PROJECT2).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT3).exe del $(PROJECT3).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT4).exe del $(PROJECT4).exe 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT5).exe del $(PROJECT5).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


