#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program 
# C/C++ Compiler Used: GNU g++ 2.7.2.1
# Produced By: Doug Gaer
# File Creation Date: 04/09/97 
# Date Last Modified: 11/03/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v -- Echo compilation
#       g -- Enable debugging
#       Wall -- Turn on warnings 
#
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = testprog

# Define macros for compiler and linker
CC = gcc
CPP = g++ 
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -v -Wall
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.o:
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

.cpp.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.cc.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.C.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<
# ===============================================================

# Build dependency rules
# ===============================================================
BNODEB_DEP = bnodeb.hpp queue.hpp sllist.hpp sllistb.hpp stack.hpp

BSTREEB_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp

RBTREEB_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp twalk.hpp

SLLISTB_DEP = sllistb.hpp

TESTPROG_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp treeprt.hpp \
	twalk.hpp ustring.hpp

TREEPRT_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp treeprt.hpp twalk.hpp

TWALK_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp twalk.hpp

USTRING_DEP = ustring.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT) 

bnodeb.o:	bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bnodeb.cpp

bstreeb.o:	bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bstreeb.cpp

rbtreeb.o:	rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) rbtreeb.cpp

sllistb.o:	sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) sllistb.cpp

testprog.o:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

treeprt.o:	treeprt.cpp $(TREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) treeprt.cpp

twalk.o:	twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) twalk.cpp

ustring.o:	ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ustring.cpp

# Make the executable
OBJS = bnodeb.o bstreeb.o rbtreeb.o sllistb.o testprog.o \
	treeprt.o twalk.o ustring.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)

# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
