#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2 
# Produced By: Doug Gaer
# File Creation Date: 04/09/97 
# Date Last Modified: 04/09/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = testprog

# Define macros for compiler and linker
CC = cl
CPP = cl
LINKER = link

# Define compiler and linker flags macros
CFLAGS= /Zi /W3
COMPILE_ONLY = /c
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.obj:
	$(CC) $(CFLAGS) $(COMPILE_ONLY) $*.c

.cpp.obj:
	$(CPP) $(CFLAGS) $(COMPILE_ONLY) $*.cpp
# ===============================================================

# Build dependency rules
# ===============================================================
BNODEB_DEP = bnodeb.hpp queue.hpp sllist.hpp sllistb.hpp stack.hpp

BSTREEB_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp

RBTREEB_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp twalk.hpp

SLLISTB_DEP = sllistb.hpp

TESTPROG_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp treeprt.hpp \
	twalk.hpp ustring.hpp

TREEPRT_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp treeprt.hpp twalk.hpp

TWALK_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp twalk.hpp

USTRING_DEP = ustring.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

bnodeb.obj:	bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bnodeb.cpp

bstreeb.obj:	bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bstreeb.cpp

rbtreeb.obj:	rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) rbtreeb.cpp

sllistb.obj:	sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) sllistb.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

treeprt.obj:	treeprt.cpp $(TREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) treeprt.cpp

twalk.obj:	twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) twalk.cpp

ustring.obj:	ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ustring.cpp

# Make the executable
OBJS = bnodeb.obj bstreeb.obj rbtreeb.obj sllistb.obj testprog.obj \
	treeprt.obj twalk.obj ustring.obj
 
$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) /OUT:$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


