// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: grocery.cpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer 
// File Creation Date: 09/18/97
// Date Last Modified: 12/04/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This is a test program used to test the (P)ersistent base class
in a practical database application.
*/
// ----------------------------------------------------------- // 
#include "grocery.hpp"
#include "os_type.hpp"

// String compare routines that need to be ported from UNIX to DOS for
// use in this application.
int NoCaseCmp(const char *s1, const char *s2)
// Compare two strings without regard to the case of the letters
{
#ifdef __DOS__
  return stricmp(s1, s2);
#endif

#ifdef __UNIX__
  return strcasecmp(s1, s2);
#endif
}

int NoCaseCmp(char *s1, char *s2)
// Compare two strings without regard to the case of the letters
{
#ifdef __DOS__
  return stricmp(s1, s2);
#endif

#ifdef __UNIX__
  return strcasecmp(s1, s2);
#endif
}

int NoCaseCmp(const UString &s1, const UString &s2)
// Compare two UString objects without regard to the case of the letters
{
#ifdef __DOS__
  return stricmp(s1.c_str(), s2.c_str());
#endif

#ifdef __UNIX__
  return strcasecmp(s1.c_str(), s2.c_str());
#endif
}

int NoCaseCmp(UString &s1, UString &s2)
// Compare two UString objects without regard to the case of the letters
{
#ifdef __DOS__
  return stricmp(s1.c_str(), s2.c_str());
#endif

#ifdef __UNIX__
  return strcasecmp(s1.c_str(), s2.c_str());
#endif
}

Grocery::Grocery(POD *pod) : Persistent(pod)
{
  itemname = "\0";
  store = "\0";
  price = 0;
  quantity = 0;
  priority = 'N';
  total = 0;
}

Grocery::Grocery(const POD *pod) : Persistent(pod)
{
  itemname = "\0";
  store = "\0";
  price = 0;
  quantity = 0;
  priority = 'N';
  total = 0;
}

Grocery::Grocery() 
{
  itemname = "\0";
  store = "\0";
  price = 0;
  quantity = 0;
  priority = 'N';
  total = 0;
}

unsigned Grocery::ObjectLength()
{
  unsigned len = StringFileLength(itemname) + \
    StringFileLength(store) + \
    sizeof(price)    + \
    sizeof(quantity) + \
    sizeof(priority) + \
    sizeof(total);
  
  return len;
}

FAU Grocery::Write()
{
  ObjectHeader oh;

  FAU addr = pod->OpenDatabase()->Alloc(ObjectLength() + sizeof(ObjectHeader));
  if(!addr) return 0;
  
  oh.ClassID = GetClassID();
  oh.ObjectID = addr;
  WriteObjHeader(oh, addr);

  FAU offset = addr+sizeof(ObjectHeader);
  WriteString(itemname, offset);
  offset = offset + StringFileLength(itemname);
  WriteString(store, offset);
  offset = offset + StringFileLength(store);
  pod->OpenDatabase()->Write(&price, sizeof(price), offset);
  offset = offset + sizeof(price);
  pod->OpenDatabase()->Write(&quantity, sizeof(quantity), offset);
  offset = offset + sizeof(quantity);
  pod->OpenDatabase()->Write(&priority, sizeof(priority), offset);
  offset = offset + sizeof(priority);
  pod->OpenDatabase()->Write(&total, sizeof(total), offset);
  objectaddress = addr;
  return addr;
}

void Grocery::Read(FAU Address)
{
  ObjectHeader oh;

  ReadObjHeader(oh, Address);
  if(oh.ClassID != GetClassID()) return; // Incorrect object type

  FAU offset = Address+sizeof(ObjectHeader);
  ReadString(itemname, offset);
  offset = offset + StringFileLength(itemname);
  ReadString(store, offset);
  offset = offset + StringFileLength(store);
  pod->OpenDatabase()->Read(&price, sizeof(price), offset);
  offset = offset + sizeof(price);
  pod->OpenDatabase()->Read(&quantity, sizeof(quantity), offset);
  offset = offset + sizeof(quantity);
  pod->OpenDatabase()->Read(&priority, sizeof(priority), offset);
  offset = offset + sizeof(priority);
  pod->OpenDatabase()->Read(&total, sizeof(total), offset);
  objectaddress = Address;
}

FAU Grocery::Find()
{
  Grocery grocery;
  FAU addr = 0;
  ObjectHeader oh;
  int result;
  
  grocery.itemname = this->itemname;
  grocery.store = this->store;
  grocery.price = this->price;
  grocery.quantity = this->quantity;
  grocery.priority = this->priority;
  grocery.total = this->total;
  
  while(1)
    {
      addr = pod->OpenDatabase()->FindFirstObject(addr);
      if(!addr) break;
      ReadObjHeader(oh, addr);
      if(oh.ClassID == GetClassID()) {
	Read(addr);
	result = NoCaseCmp(itemname, grocery.itemname);
	if(result == 0) {
	  objectaddress = addr;
	  return addr; // Found unique data member
	}
	else {
	  // Reset the objects data
	  this->itemname = grocery.itemname;
	  this->store = grocery.store;
	  this->price = grocery.price;
	  this->quantity = grocery.quantity;
	  this->priority = grocery.priority;
	  this->total = grocery.total;
	}
      }
    }
  return 0; // Could not find 
}

void Grocery::Copy(const Grocery &ob)
{
  itemname = ob.itemname;
  store = ob.store;
  price = ob.price;
  quantity = ob.quantity;
  price = ob.price;
  priority = ob.priority;
  total = ob.total;
}

int Grocery::FullCompare(const Grocery &ob)
{
  if(ob.itemname != itemname) return 0;
  if(ob.store != store) return 0;
  if(ob.price != price) return 0;
  if(ob.quantity != quantity) return 0;
  if(ob.priority != priority) return 0;
  if(ob.total != total) return 0;
  return 1;
}

int operator==(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) == 0;
}

int operator!=(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) != 0;
}

int operator>(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) > 0;
}

int operator>=(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) >= 0;
}
  
int operator<(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) < 0;
}
  
int operator<=(const Grocery &a, const Grocery &b)
{
  return NoCaseCmp(a.GetName(), b.GetName()) <= 0;
}
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
