// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: grocery.hpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 09/17/97  
// Date Last Modified: 12/04/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This is a test program used to test the (P)ersistent base class
in a practical database application.
*/
// ----------------------------------------------------------- //   
#ifndef __GROCERY_HPP
#define __GROCERY_HPP

#include "persist.hpp"
#include "float64.hpp"

const INT32 GroceryID      = 1000;
const INT32 GroceryVersion = 1024;

typedef UString ItemName;
typedef UString Store;
typedef FLOAT64 Price;
typedef INT32   Quantity;
typedef SBYTE   Priority;
typedef FLOAT64 Total;

class Grocery : public Persistent
{
public:
  Grocery(POD *pod);
  Grocery(const POD *pod);
  Grocery();
  Grocery(const Grocery &ob) { Copy(ob); }
  void operator=(const Grocery &ob) { Copy(ob); }
  ~Grocery() { }
  
public:
  void SetName(const char *s) { itemname = s; }
  void SetName(const UString &s) { itemname = s; }
  void SetStore(const char *s) { store = s; }
  void SetStore(const UString &s) { store = s; }
  void SetPrice(Price p) { price = p; }
  void SetQuantity(Quantity q) { quantity = q; }
  void SetPriority(Priority p) { priority = p; }
  void SetTotal(Total t) { total = t; }
  char *GetName() { return itemname.c_str(); }
  char *GetStore() { return store.c_str(); }
  const char *GetName() const { return itemname.c_str(); }
  const char *GetStore() const { return store.c_str(); }
  Price GetPrice() { return price; }
  Price GetPrice() const { return price; }
  Quantity GetQuantity() { return quantity; }
  Quantity GetQuantity() const { return quantity; }
  Priority GetPriority() { return priority; }
  Priority GetPriority() const { return priority; }
  Total GetTotal() { return total; }
  Total GetTotal() const { return total; }
  
public:
  void Copy(const Grocery &ob);
  int FullCompare(const Grocery &ob);
  
private: // Base class interface
  virtual INT32 GetClassID() const { return GroceryID; }
  virtual const char *GetClassName() { return "Class Grocery"; }
  virtual FAU Write();
  virtual void Read(FAU Address);
  virtual FAU Find();
  
public: // Base class interface
  virtual unsigned ObjectLength();
  virtual void SetObjectAddress(FAU addr) { objectaddress = addr; }
  virtual FAU GetObjectAddress() { return objectaddress; }
  
public: // Overloaded operators
  friend int operator==(const Grocery &a, const Grocery &b);
  friend int operator!=(const Grocery &a, const Grocery &b);
  friend int operator>(const Grocery &a, const Grocery &b);
  friend int operator>=(const Grocery &a, const Grocery &b);
  friend int operator<(const Grocery &a, const Grocery &b);
  friend int operator<=(const Grocery &a, const Grocery &b);

private:
  ItemName itemname;
  Store    store;
  Price    price;
  Quantity quantity;
  Priority priority;
  Total    total;
};

// String compare routines that need to be ported from UNIX to DOS for
// use in this application.
int NoCaseCmp(const char *s1, const char *s2);
int NoCaseCmp(char *s1, char *s2);
int NoCaseCmp(const UString &s1, const UString &s2);
int NoCaseCmp(UString &s1, UString &s2);

#endif  // __GROCERY_HPP //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
