#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program
# C/C++ Compiler Used: HP C++ A.10.24  compiled for HP-UX 10.20 
# Produced By: Doug Gaer
# File Creation Date: 09/18/97 
# Date Last Modified: 10/22/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v    -- Echo compilation
#       g    -- Enable debugging
#	+w   -- Turn on all warnings
#       +eh  -- Enable C++ exception handling
#	+a1  -- Allow ANSI C automatic aggregate initialization	
#	-pta -- Instantiate entire template class
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = grocery

# Define macros for compiler and linker
CC = cc
CPP = CC
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= +eh +a1 -pta
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS = -lcurses -ltermcap

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.o:
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

.cpp.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.cc.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.C.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<
# ===============================================================

# Build dependency rules
# ===============================================================
VBDFILE_DEP = dtypes.hpp ehandler.hpp int32.hpp refcount.hpp vbdfile.hpp

BSTREE_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp

EHANDLER_DEP = ehandler.hpp os_type.hpp terminal.hpp

FLOAT64_DEP = dtypes.hpp ehandler.hpp float64.hpp machine.hpp

GROCERY_DEP = dtypes.hpp ehandler.hpp float64.hpp grocery.hpp int32.hpp \
	os_type.hpp persist.hpp pod.hpp refcount.hpp ustring.hpp \
	vbdfile.hpp

INT32_DEP = dtypes.hpp ehandler.hpp int32.hpp

MAIN_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp dtypes.hpp ehandler.hpp \
	float64.hpp grocery.hpp int32.hpp os_type.hpp persist.hpp \
	pod.hpp queue.hpp rbnode.hpp rbtree.hpp rbtreeb.hpp refcount.hpp \
	sllist.hpp sllistb.hpp stack.hpp terminal.hpp twalk.hpp \
	ustring.hpp vbdfile.hpp chslist.hpp config.hpp

PERSIST_DEP = dtypes.hpp ehandler.hpp int32.hpp persist.hpp pod.hpp \
	refcount.hpp ustring.hpp vbdfile.hpp

POD_DEP = dtypes.hpp ehandler.hpp int32.hpp pod.hpp refcount.hpp \
	ustring.hpp vbdfile.hpp

RBTREE_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp \
	twalk.hpp

SLLISTB_DEP = sllistb.hpp

TERMINAL_DEP = os_type.hpp terminal.hpp

TWALK_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp twalk.hpp

USTRING_DEP = ustring.hpp

BNODEB_DEP = bnodeb.hpp queue.hpp sllist.hpp sllistb.hpp stack.hpp

CHSLIST_DEP = chslist.hpp sllistb.hpp

CONFIG_DEP = chslist.hpp config.hpp sllistb.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT) 

ehandler.o:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

float64.o:	float64.cpp $(FLOAT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) float64.cpp

int32.o:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

vbdfile.o:    vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vbdfile.cpp

pod.o:    pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) pod.cpp

persist.o:    persist.cpp $(PERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) persist.cpp

main.o:	main.cpp $(MAIN_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) main.cpp

ustring.o:	ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ustring.cpp

grocery.o:	grocery.cpp $(GROCERY_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) grocery.cpp

terminal.o:	terminal.cpp $(TERMINAL_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) terminal.cpp

bnodeb.o:	bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bnodeb.cpp

bstreeb.o:	bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bstreeb.cpp

rbtreeb.o:	rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) rbtreeb.cpp

sllistb.o:	sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) sllistb.cpp

twalk.o:	twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) twalk.cpp

chslist.o:	chslist.cpp $(CHSLIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) chslist.cpp

config.o:	config.cpp $(CONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) config.cpp

# Make the executable
OBJS = ehandler.o float64.o int32.o vbdfile.o main.o \
	persist.o ustring.o pod.o grocery.o terminal.o \
	bnodeb.o bstreeb.o rbtreeb.o sllistb.o twalk.o  \
	chslist.o config.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) $(LFLAGS)
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing template repository from working directory...
	rm -r -f ptrepository
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
