// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: part.cpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer 
// File Creation Date: 09/18/97
// Date Last Modified: 12/04/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.
  
This is a test program used to test the (P)ersistent base class.
*/
// ----------------------------------------------------------- // 
#include "part.hpp"

unsigned Part::ObjectLength()
{
  return sizeof(id) + sizeof(price) + StringFileLength(name);
}

FAU Part::Write()
{
  ObjectHeader oh;

  FAU addr = pod->OpenDatabase()->Alloc(ObjectLength() + sizeof(ObjectHeader));
  if(!addr) return 0;
  
  oh.ClassID = GetClassID();
  oh.ObjectID = addr;
  WriteObjHeader(oh, addr);

  FAU offset = addr+sizeof(ObjectHeader);
  pod->OpenDatabase()->Write(&id, sizeof(id), offset);
  offset = offset + sizeof(id);
  pod->OpenDatabase()->Write(&price, sizeof(price), offset);
  offset = offset + sizeof(price);
  WriteString(name, offset);
  return addr;
}

void Part::Read(FAU Address)
{
  ObjectHeader oh;

  ReadObjHeader(oh, Address);
  if(oh.ClassID != GetClassID()) return; // Incorrect object type

  FAU offset = Address+sizeof(ObjectHeader);
  pod->OpenDatabase()->Read(&id, sizeof(id), offset);
  offset = offset + sizeof(id);
  pod->OpenDatabase()->Read(&price, sizeof(price), offset);
  offset = offset + sizeof(price);
  ReadString(name, offset);
}

FAU Part::Find()
{
  UString buf;
  Part part;
  FAU addr = 0;
  ObjectHeader oh;

  part.id = this->id;
  part.price = this->price;
  part.name = this->name;
  
  while(1)
    {
      addr = pod->OpenDatabase()->FindFirstObject(addr);
      if(!addr) break;
      ReadObjHeader(oh, addr);
      if(oh.ClassID == GetClassID()) {
	Read(addr);
	if(name == part.name)
	  return addr; // Found unique data member
	else {
	  // Reset the objects data
	  this->id = part.id;
	  this->price = part.price;
	  this->name = part.name;
	}
      }
    }
  return 0; // Could not find 
}
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
