// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: persist.hpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer    
// File Creation Date: 09/18/97 
// Date Last Modified: 12/03/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The (P)ersistent base class is used to define the interface 
that makes the object persistent. 
*/
// ----------------------------------------------------------- //   
#ifndef __PERSIST_HPP
#define __PERSIST_HPP

#include "pod.hpp"

// (O)bject (H)eader (8 bytes total)
struct ObjectHeader
{
  INT32 ClassID;    // Class Identification number (4 bytes)
  FAU ObjectID;     // Object Identifcation number (4 bytes)
};

// (P)ersistent base class
class Persistent
{
public:
  Persistent(POD *DB) { Connect(DB); objectaddress = 0; }
  Persistent(const POD *DB) { Connect(DB); objectaddress = 0; }
  Persistent() { pod = 0; } 

private:
  Persistent(const Persistent &ob) { } // Disallow coping
  void operator=(const Persistent &ob) { } // Disallow assignment
  
protected: // Derived class interface
  virtual INT32 GetClassID() const = 0;
  virtual const char *GetClassName() = 0;
  virtual FAU Write() = 0;
  virtual void Read(FAU Address) = 0;
  virtual FAU Find() = 0;
  virtual unsigned ObjectLength() = 0;
  virtual FAU GetObjectAddress() = 0;
  virtual void SetObjectAddress(FAU addr) = 0;
  
protected:
  void WriteObjHeader(const ObjectHeader &oh, FAU addr);
  void ReadObjHeader(ObjectHeader &oh, FAU addr);
  void Connect(POD *DB); // Connects persistent class to open database
  void Connect(const POD *DB);
  unsigned StringFileLength(const UString &s); // Length of string in file 
  void WriteString(const UString &s, FAU addr);
  void ReadString(UString &s, FAU addr);

public: // User interface
  FAU AddObject(int find = 1);
  void ReadObject(FAU addr) { Read(addr); }
  FAU FindObject() { return Find(); }
  FAU DeleteObject();
  void DeleteObject(FAU addr);
  FAU RemoveObject();
  void RemoveObject(FAU addr);
  FAU ObjectAddress(int find = 1);
  
protected:
  POD *pod;
  FAU objectaddress;
};

#endif // __PERSIST_HPP
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
