// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: pod.cpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 09/18/97  
// Date Last Modified: 12/03/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The (P)ersistent (O)bject (D)atabase manager is used to manage
the file pointers to VBD files.
*/
// ----------------------------------------------------------- // 
#include "pod.hpp"

POD::POD(UString &FN, VBDFile::AccessMode mode)
{
  if(!VBDFile::Exists(FN.c_str())) {
    Create(FN.c_str());
    exists = 0;
  }
  else {
    Open(FN.c_str(), mode);
    exists = 1;
  }
}

POD::POD(const char *FN, VBDFile::AccessMode mode)
{
  if(!VBDFile::Exists(FN)) {
    Create(FN);
    exists = 0;
  }
  else {
    Open(FN, mode);
    exists = 1;
  }
}

int POD::Connect(VBDFilePtr &fp)
{
  if(!fp) return 0;
  opendatabase = fp; 
  if (opendatabase->IsOK()) return 1; else return 0;
}

int POD::Create(const UString &FN)
{
  Disconnect();
  VBDFilePtr tmp(new VBDFile);
  VBDFilePtr nul = 0; // Used to satisfy overloaded == in SmartPtr class 
  if (tmp == nul) return 0;
  tmp->Create(FN.c_str());
  if (!tmp->IsOK()) return 0;
  return Connect(tmp);
}

void POD::Disconnect()
// Disconnects the database from the file.
{
  if (opendatabase) {
    opendatabase->Close();
    opendatabase = 0;
  }
}

void POD::Flush()
{
  if (opendatabase->IsOK()) {
     if (opendatabase->ReadyForWriting()) {
        opendatabase->Flush();
     }
  }
}

int POD::Open(const UString &FN, VBDFile::AccessMode mode)
{
  Disconnect();
  VBDFilePtr tmp(new VBDFile);
  VBDFilePtr nul = 0; // Used to satisfy overloaded == in SmartPtr class 
  if (tmp == nul) return 0;
  tmp->Open(FN.c_str(), mode);
  if (!tmp->IsOK()) return 0;
  return Connect(tmp);
}

int POD::Open(const char *FN, VBDFile::AccessMode mode)
{
  Disconnect();
  VBDFilePtr tmp(new VBDFile);
  VBDFilePtr nul = 0; // Used to satisfy overloaded == in SmartPtr class 
  if (tmp == nul) return 0;
  tmp->Open(FN, mode);
  if (!tmp->IsOK()) return 0;
  return Connect(tmp);
}
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
