// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: pod.hpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer    
// File Creation Date: 09/18/97 
// Date Last Modified: 12/03/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The (P)ersistent (O)bject (D)atabase manager is used to manage
the file pointers to VBD files.
*/
// ----------------------------------------------------------- //   
#ifndef __POD_HPP
#define __POD_HPP

#include "vbdfile.hpp"
#include "ustring.hpp"

class Persistent;

// (P)ersistent (O)bject (D)atabase manager class
class POD
{
public:
  POD(UString &FN, VBDFile::AccessMode mode = VBDFile::READWRITE);
  POD(const char *FN, VBDFile::AccessMode mode = VBDFile::READWRITE);
  ~POD() { Disconnect(); }
  
private:
  POD(const POD &ob) { }            // Disallow coping
  void operator=(const POD &ob) { } // Disallow assignment

public:
  int Open(const UString &FN, VBDFile::AccessMode mode = VBDFile::READWRITE);
  int Open(const char *FN, VBDFile::AccessMode mode = VBDFile::READWRITE);
  void Disconnect();
  int Create(const UString &FN);
  void Flush();
  void Close() { Disconnect(); }
  int Connect(VBDFilePtr &fp);
  VBDFilePtr OpenDatabase() { return opendatabase; }
  VBDFilePtr OpenDatabase() const { return opendatabase; }
  int Exists() const { return exists; }
  int Exists() { return exists; }
  
private:
  VBDFilePtr opendatabase; // Variable Block file pointer to the database
  int exists; // True if file already exists
};

#endif // __POD_HPP
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
