#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the database program  
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2 
# Produced By: Doug Gaer
# File Creation Date: 09/18/97 
# Date Last Modified: 10/30/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#       GX -- Enable C++ exception handling
#       GR -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = landbt # Database Terminal interface

# Define macros for compiler and linker
CC = cl
CPP = cl
LINKER = link

# Define compiler and linker flags macros
CFLAGS= /Zi /GX 
COMPILE_ONLY = /c
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.obj:
	$(CC) $(CFLAGS) $(COMPILE_ONLY) $*.c

.cpp.obj:
	$(CPP) $(CFLAGS) $(COMPILE_ONLY) $*.cpp
# ===============================================================

# Build dependency rules
# ===============================================================
VBDFILE_DEP = dtypes.hpp ehandler.hpp int32.hpp refcount.hpp vbdfile.hpp

BSTREE_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp

EHANDLER_DEP = ehandler.hpp os_type.hpp terminal.hpp

STRDB_DEP = dtypes.hpp ehandler.hpp strdb.hpp int32.hpp os_type.hpp \
	persist.hpp pod.hpp refcount.hpp ustring.hpp vbdfile.hpp \
	dbvers.hpp

INT32_DEP = dtypes.hpp ehandler.hpp int32.hpp

STRDBT_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp dtypes.hpp ehandler.hpp \
	strdb.hpp int32.hpp os_type.hpp persist.hpp pod.hpp queue.hpp \
	rbnode.hpp rbtree.hpp rbtreeb.hpp refcount.hpp 	sllist.hpp \
	sllistb.hpp stack.hpp terminal.hpp twalk.hpp ustring.hpp \
	vbdfile.hpp chslist.hpp config.hpp dbconfig.hpp timer.hpp \
	dbvers.hpp version.hpp dbtcfg.hpp

PERSIST_DEP = dtypes.hpp ehandler.hpp int32.hpp persist.hpp pod.hpp \
	refcount.hpp ustring.hpp vbdfile.hpp

POD_DEP = dtypes.hpp ehandler.hpp int32.hpp pod.hpp refcount.hpp \
	ustring.hpp vbdfile.hpp

RBTREE_DEP = bnode.hpp bnodeb.hpp bstreeb.hpp queue.hpp rbnode.hpp \
	rbtree.hpp rbtreeb.hpp sllist.hpp sllistb.hpp stack.hpp \
	twalk.hpp

SLLISTB_DEP = sllistb.hpp

TERMINAL_DEP = os_type.hpp terminal.hpp

TWALK_DEP = bnode.hpp bnodeb.hpp queue.hpp rbnode.hpp sllist.hpp \
	sllistb.hpp stack.hpp twalk.hpp

USTRING_DEP = ustring.hpp

BNODEB_DEP = bnodeb.hpp queue.hpp sllist.hpp sllistb.hpp stack.hpp

CHSLIST_DEP = chslist.hpp sllistb.hpp

CONFIG_DEP = chslist.hpp config.hpp sllistb.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

ehandler.obj:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

int32.obj:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

vbdfile.obj:    vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vbdfile.cpp

pod.obj:    pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) pod.cpp

persist.obj:    persist.cpp $(PERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) persist.cpp

strdbt.obj:	strdbt.cpp $(STRDBT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) strdbt.cpp

ustring.obj:	ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ustring.cpp

strdb.obj:	strdb.cpp $(STRDB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) strdb.cpp

terminal.obj:	terminal.cpp $(TERMINAL_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) terminal.cpp

bnodeb.obj:	bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bnodeb.cpp

bstreeb.obj:	bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) bstreeb.cpp

rbtreeb.obj:	rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) rbtreeb.cpp

sllistb.obj:	sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) sllistb.cpp

twalk.obj:	twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) twalk.cpp

chslist.obj:	chslist.cpp $(CHSLIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) chslist.cpp

config.obj:	config.cpp $(CONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) config.cpp

# Make the executable
OBJS = ehandler.obj int32.obj vbdfile.obj strdbt.obj persist.obj \
	ustring.obj pod.obj strdb.obj terminal.obj bnodeb.obj \
	bstreeb.obj rbtreeb.obj sllistb.obj twalk.obj chslist.obj \
	config.obj 

$(PROJECT).exe:	$(OBJS)
	$(LINKER) $(LFLAGS) $(OBJS) /OUT:$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


