// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: fstring.hpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 02/07/97  
// Date Last Modified: 12/04/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This is fixed length (static) string class.
*/
// ----------------------------------------------------------- //   
#ifndef __FSTRING_HPP
#define __FSTRING_HPP

#include <string.h>
#include <iostream.h>
#include <iomanip.h>

const unsigned Len = 25; // String length of the fixed string

class FString 
{ 
public:
  FString() { Clear(); }
  FString(char *s) { Store(s); }
  ~FString() { }    

  FString(const FString &s) { Copy(s); }

  FString &operator=(const FString &s) {
    if(this != &s) {
      Copy(s);
    }
    return *this;
  }

  FString &operator=(int) { Clear(); return *this; }
  
public:
  void Store(char *s);
  void Store(const char *s);
  void Clear();
  void Copy(const FString &s);
  char *c_str();
  const char *c_str() const;
  
public:
  friend int operator==(const FString &a, const FString &b) {
    return strcmp(a.str, b.str) == 0;
  }

  friend int operator<(const FString &a, const FString &b) {
    return strcmp(a.str, b.str) < 0;
  }

  friend int operator>(const FString &a, const FString &b) {
    return strcmp(a.str, b.str) > 0;
  }

  friend int operator!=(const FString &a, const FString &b) {
    return strcmp(a.str, b.str) != 0;
  }
  
  friend ostream &operator<<(ostream &os, const FString &s) {
    return os.write(s.str, strlen(s.str));
  }

  friend istream &operator>>(istream &os, FString &s) {
    os >> setw(strlen(s.str)) >> s.str;
    return os;
  }
	       
private:
  char str[Len];
};

#endif  // __FSTRING_HPP //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
