#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program 
# C/C++ Compiler Used: GNU gcc 2.7.2.1 
# Produced By: Doug Gaer
# File Creation Date: 04/14/97 
# Date Last Modified: 09/16/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v -- Echo compilation
#       g -- Enable debugging
#       Wall -- Turn on warnings 
#       -fhandle-exceptions -- Enable C++ exception handling
#       -frtti              -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = testprog

# Define macros for compiler and linker
CC = gcc
CPP = g++ 
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -v -Wall -fhandle-exceptions
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.o:
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

.cpp.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.cc.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.C.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<
# ===============================================================

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ehandler.hpp 

VBDFILE_DEP = ehandler.hpp vbdfile.hpp refcount.hpp dtypes.hpp \
	int32.hpp

INT32_DEP = dtypes.hpp ehandler.hpp int32.hpp

TESTPROG_DEP = vbdfile.hpp ehandler.hpp refcount.hpp

USTRING_DEP = ustring.hpp
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT) 


ehandler.o:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

vbdfile.o:	vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vbdfile.cpp

testprog.o:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

ustring.o:	ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ustring.cpp

int32.o:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

# Make the executable
OBJS = ehandler.o vbdfile.o testprog.o ustring.o int32.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
