#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the VBD utility program
# C/C++ Compiler Used: DJGPP gcc 2.7.2.1 compiled for MSDOS 
# Produced By: Doug Gaer
# File Creation Date: 09/05/97 
# Date Last Modified: 11/07/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v                   -- Echo compilation
#       g                   -- Enable debugging
#       Wall                -- Turn on warnings 
#       -fhandle-exceptions -- Enable C++ exception handling
#       -frtti              -- Enable C++ Run-Time Type Information
#
# Linker flags using gcc or ld
#	-lgpp    -- C++ Linkage
#	-lstdcx  -- Needed for Exception Handling and RTTI
#	-lm      -- Needed for Exception Handling
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = vb_debug

# Define macros for compiler and linker
CC = gcc
CPP = gcc
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -fhandle-exceptions 
COMPILE_ONLY = -c
OUTPUT = -o
CPP_FLAG = -lgpp -lstdcx     
LFLAGS =  

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ehandler.hpp

INT32_DEP = int32.hpp ehandler.hpp dtypes.hpp

DVBDFILE_DEP = dtypes.hpp ehandler.hpp int32.hpp dvbdfile.hpp \
	refcount.hpp 

VB_DEBUG_DEP = dtypes.hpp ehandler.hpp int32.hpp dvbdfile.hpp \
	refcount.hpp 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

ehandler.o:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

int32.o:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

dvbdfile.o:    dvbdfile.cpp $(DVBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) dvbdfile.cpp

vbdstats.o:    vbdstats.cpp $(VBDSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vbdstats.cpp

hexdump.o:    hexdump.cpp $(HEXDUMP_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) hexdump.cpp

vb_debug.o:	vb_debug.cpp $(VB_DEBUG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vb_debug.cpp

# Make the executable
OBJS = ehandler.o int32.o dvbdfile.o vb_debug.o

$(PROJECT):	$(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) $(CPP_FLAG)
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing COFF file from working directory...
	rm -f $(PROJECT)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
