// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: dtypes.hpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 09/05/97  
// Date Last Modified: 12/03/97
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This file contains typedefs and constants used to maintain
compatiblity between the built-in data type sizes on various
compilers.
*/
// ----------------------------------------------------------- //   
#ifndef __DTYPES_HPP
#define __DTYPES_HPP

typedef char SBYTE;            // 8-bit signed value
typedef unsigned char UBYTE;   // 8-bit unsigned value
typedef int WORD;              // (W)ord size (4 bytes) 
typedef unsigned UWORD;        // (U)nsigned (W)ord size (4 bytes)
typedef long LWORD;            // (L)ong (W)ord size (4 bytes)
typedef unsigned long ULWORD;  // (U)nsigned (L)ong (W)ord size (4 Bytes)
typedef short SWORD;           // (S)hort (W)ord size (2 bytes)
typedef unsigned short USWORD; // (U)nsigned (S)hort int size (2 bytes) 
typedef double DPFLOAT; // (D)ouble (P)recision (F)loating point (8 bytes)

// Constants
const LWORD   LWORDPositiveLimit = 2147483647;
const LWORD   LWORDNegitiveLimit = 2147483648;
const ULWORD  ULWORDLimit        = 4294967295;
const WORD    WORDPositiveLimit  = 2147483647;
const WORD    WORDNegitiveLimit  = 2147483648;
const UWORD   UWORDLimit         = 4294967295;
const SWORD   SWORDPositiveLimit = 32767;
const SWORD   SWORDNegitiveLimit = 32768;
const USWORD  USWORDLimit        = 65535;
const DPFLOAT DPFLOATPositiveLimit = 1.7E+308; // (15 digit precision)
const DPFLOAT DPFLOATNegitiveLimit = 1.7E-308; // (15 digit precision)

#endif // __DTYPES_HPP
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
