#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the VBD utility program
# C/C++ Compiler Used: GNU g++ 2.7.2.1 
# Produced By: Doug Gaer
# File Creation Date: 09/05/97 
# Date Last Modified: 11/07/97 
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v                   -- Echo compilation
#       g                   -- Enable debugging
#       Wall                -- Turn on warnings 
#       -fhandle-exceptions -- Enable C++ exception handling
#       -frtti              -- Enable C++ Run-Time Type Information
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = vb_debug

# Define macros for compiler and linker
CC = gcc
CPP = g++
LINKER = ld

# Define compiler and linker flags macros
CFLAGS= -fhandle-exceptions
COMPILE_ONLY = -c
OUTPUT = -o
LFLAGS =  

# General inference rules
# ===============================================================
# Rule to make object files from C/C++ source code files
.c.o:
	$(CC) $(COMPILE_ONLY) $(CFLAGS) $<

.cpp.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.cc.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<

.C.o:
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $<
# ===============================================================

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ehandler.hpp

INT32_DEP = int32.hpp ehandler.hpp dtypes.hpp

DVBDFILE_DEP = dtypes.hpp ehandler.hpp int32.hpp dvbdfile.hpp \
	refcount.hpp 

VB_DEBUG_DEP = dtypes.hpp ehandler.hpp int32.hpp dvbdfile.hpp \
	refcount.hpp 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

ehandler.o:	ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) ehandler.cpp

int32.o:	int32.cpp $(INT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) int32.cpp

dvbdfile.o:    dvbdfile.cpp $(DVBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) dvbdfile.cpp

vbdstats.o:    vbdstats.cpp $(VBDSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vbdstats.cpp

hexdump.o:    hexdump.cpp $(HEXDUMP_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) hexdump.cpp

vb_debug.o:	vb_debug.cpp $(VB_DEBUG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) vb_debug.cpp

# Make the executable
OBJS = ehandler.o int32.o dvbdfile.o vb_debug.o

$(PROJECT):	$(OBJS)
	$(CPP) $(CFLAGS) $(OBJS) $(OUTPUT) $(PROJECT) 
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
